'*******************************************************************************
'*  Name    : I2C_Multi_Master Mehrfach-Controler Software                     *
'*          ; fr 8 TRX-Einschub                                               *
'*  Author  : Tomtom DL1MFK                                                    *
'*  Notice  : Copyright (c) 2015                                               *
'*          : All Rights Reserved                                              *
'*  Date    : 26.05.2016                                                       *
'*          :                                                                  *
'*  Version : 0.6b                                                             *
'*          : - Doppelprfung FRAM_Lesen eingebaut                             *
'*          : - Alte ZF-angepasst                                              *
'*          : - RX_Typ1 Frequenzfehler behoben                                 *
'*          : - Menueausstieg verndert                                        *
'*          :                                                                  *
'*  Version : 0.6a                                                             *
'*          : - debugs0 gekillt                                                *
'*          :                                                                  *
'*  Version : 0.5a                                                             *
'*          : - kollisionen und Bushnger in TomTWi.lib gekillt                *
'*          :                                                                  *
'*  Version : 0.4i                                                             *
'*          : - Keine Include Dateien mehr weil Compiler spinnt                *
'*          : -                                                                *
'*          :                                                                  *
'*          :                                                                  *
'*  Version : 0.4f/g                                                           *
'*          : - Fram Fehlerprozeduren gendert                                 *
'*          : - TWCR Reset bei Bus-Fehler ????                                 *
'*          :                                                                  *
'*  Version : 0.4e                                                             *
'*          : - RX und TX Frequenzbereich auf 250-4000MHz erweitert            *
'*          : - StepFaktor auf 128 erweitert                                   *
'*          : - TX-Typ kann jetzt uf 3 gestellt werden                         *
'*          :                                                                  *
'*  Version : 0.4d                                                             *
'*          : - Kleinigkeiten verbessert                                       *
'*          :                                                                  *
'*  Version : 0.4c                                                             *
'*          : - Typ Test eingefgt beim FRAM Lesen                             *
'*          :                                                                  *
'*  Version : 0.4c                                                             *
'*          : - Schalternamen knnen jetzt richtig eingegeben werden           *
'*          : - OSD-Call jetzt bei neueingabe vorgegeben                       *
'*          : - IC-Meldungen unterdrckt                                      *
'*          :                                                                  *
'*  Version : 0.4a                                                             *
'*          : - scheint Fehlerfrei zu laufen Debugs kurz angezeigt             *
'*          : - PCF-Einstellung jetzt auch OK                                  *
'*          : - Bei MT-Time out wird Bus nicht mehr low geschaltet !!!         *
'*          : - PCF-Lesen Fehler gendert                                      *
'*          : - RelDil wird richtig ausgelesen und geschrieben                 *
'*          : - Anzeige-Fehler QRG hinterm Komma                               *
'*          : - EEProm Daten in andere Reihenfolge wie FRAM gendert           *
'*          : - OSD-Call bearbeitung eingebaut                                 *
'*          : - Menuefunktionen umgebaut und Rcksprungfehler behoben          *
'*          : - HMenuenr nimmer aus EEProm immer beim Start auf 1              *
'*          : - Schalter funktionen eingebaut                                  *
'*          :                                                                  *
'*******************************************************************************
'* Typ Deklarationen:                                                          *
'*                                                                             *
'* RX Typ 1 : Alter RX (LC72xx) mit alter Steuerung (PIC 16F88)                *
'*          :                                                                  *
'* RX Typ 2 : Alter RX (LC72xx) mit neuer Steuerung (ATMega 8 oder 168 etc)    *
'*          :                                                                  *
'* RX Typ 3   Neuer RX mit neuer Steuerung (ATMega 8 oder 168 etc)             *
'*          :                                                                  *
'*          :                                                                  *
'* TX Typ 1 : Alter TX (MB1501) mit alter Steuerung (PIC 16F88)                *
'*          :                                                                  *
'* TX Typ 2 : Alter TX (MB1501) mit neuer Steuerung (ATMega 8 oder 168 etc)    *
'*          :                                                                  *
'* TX Typ 2 : Neuer TX (ATTiny45) mit neuer Steuerung (ATMega 8 oder 168 etc)  *
'*          :                                                                  *
'*******************************************************************************
$regfile = "M328pdef.dat"
$crystal = 8000000
'$baud = 115200
$hwstack = 164
$swstack = 164
$framesize = 164
Const Titel = "EWMS STRG"
Const Versionsnummer = "6b 05/16"
'*******************************************************************************
'*   LCD-Leitungen                                                             *
'*******************************************************************************
'       LCD       Mega8
'       ----     -------
'       DB4      PortB.7
'       DB5      PortD.5
'       DB6      PortB.6
'       DB7      PortD.6
'       E        PortD.0
'       RS       PortD.7
'       RW       Masse
'       Vdd      5 Volt
'       Vss      Masse
'       Vo       10K-Poti
'
Config Lcdpin = Pin , E = Portb.0 , Rs = Portd.7 , Db4 = Portb.7 , Db5 = Portd.5 , Db6 = Portb.6 , Db7 = Portd.6
Config Lcdbus = 4
Config Lcd = 40 * 2
'*******************************************************************************
'*   PCA Konfiguration                                                         *
'*******************************************************************************
Config Pinb.1 = Output
Config Pinb.2 = Output
Config Pinc.2 = Output
Config Pinc.3 = Output

Pca_0 Alias Portb.2                                        ' PCA-Adresse anlegen
Pca_1 Alias Portc.3
Pca_2 Alias Portb.1
Pca_r Alias Portc.2                                        ' PCA-Reset-Pin
'*******************************************************************************
'*   Tasten                                                                    *
'*******************************************************************************
Config Pind.2 = Input
Config Pind.3 = Input
Config Pind.4 = Input
Portd.2 = 1                                                ' Pullups einschalten
Portd.3 = 1                                                ' Pullups einschalten
Portd.4 = 1                                                ' Pullups einschalten
T_menu Alias Pind.2                                        ' Menu Taste  PD2 Pin 4
T_ab Alias Pind.3                                          ' Ab-taste    PD3 Pin 5
T_auf Alias Pind.4                                         ' Auf-Taste   PD4 Pin 6
'*******************************************************************************
'*   TWI setup                                                                 *
'*******************************************************************************
$lib "TomTWi.LIB"

$external Twi_sense
$external Mst_start
$external Mst_stop
$external Twi_mst_slv_isr


'-------------------------------------
'  twi-STRUCTURE MASTER
'-------------------------------------
Dim Twi_mst_flag As Byte                                    '0     Kontroll-flags
Dim Twi_mst_addr As Byte                                    '1     SLA + R/W

Dim Twi_mt_curr As Byte                                     '0     resv
Dim Twi_mt_data As Word                                     '1/2   Data address
Dim Twi_mt_cntr As Byte                                     '3     anzahl bytes

Dim Twi_mr_curr As Byte                                     '0     resv
Dim Twi_mr_data As Word                                     '1/2   Data address
Dim Twi_mr_cntr As Byte                                     '3     anzahl bytes

'-------------------------------------
'  twi-STRUCTURE SLAVE RECV / TRANS
'-------------------------------------
Dim Twi_slv_flag As Byte                                    '0     Kontroll-flags
Dim Twi_slv_addr As Byte                                    '1     slave adresse
Dim Twi_slv_stat As Byte                                    '2     twi-state (SLA)

Dim Twi_sr_cntr As Byte                                     '0     anzahl bytes
Dim Twi_sr_data As Word                                     '1/2   Data-address

Dim Twi_st_cntr As Byte                                     '0     anzahl bytes
Dim Twi_st_data As Word                                     '1/2   Data-address


Const Twi_m_sent = 1
Const Twi_m_recv = 2
Const Twi_timeout = 3
Const Twi_m_busy = 4
Const Twi_buserr = 7

Config Twi = 65000                                          ' 50 kHz
' Twcr = &B00000100                                         ' TWI gleich einschalten (nur TWEN setzen)
' Kein Slave-Betrieb !!!!
On Twi Twi_mst_slv_isr , Nosave                             ' ISR f. TWI
'*******************************************************************************
'*   I2C Leitungen                                                             *
'*******************************************************************************
T_scl Alias Pinc.5                                          ' Fr Leitung Down Prfung
T_sda Alias Pinc.4
Config Pinc.5 = Input                                       ' Leitungen Hochohmig schalten
Config Pinc.4 = Input
'*******************************************************************************
'*   Timer Konfiguration                                                       *
'*******************************************************************************
Config Timer0 = Timer , Prescale = 1024                     ' konfiguriere Timer0 fr Framabfrage
On Timer0 Fram_timer                                        ' Fram-Abfrage Timer Interrupt Verweis

Config Timer2 = Timer , Prescale = 1024                     ' konfiguriere Timer2 fr Menu-Ausstieg
On Timer2 Menue_timer                                       ' Menu Ausstieg Timer Interrupt Verweis
'*******************************************************************************
'*   Sub-Deklarationen                                                         *
'*******************************************************************************
' Menue-Anzeige
Declare Sub Menue(byref Menuenr As Byte , Byval Maxmenue As Byte)
' TRX 1-8 Zhler
Declare Sub Auf_ab(byref Parameter As Dword , byref Step_khz As Word , byref Faktor_step As Byte , byref Faktor As Byte , byref Lo_p_m As Byte , byref Lo_x As Word , Byval Pmax As Dword , Byval Pmin As Dword , Byval Ptrx As String)
' Bit ein und ausschalten
Declare Sub Bit_ein_aus(byref Bit_parameter As Byte , Byval Anzeige_bit As String , Byval Max_zustand As Byte , Byval Lcd0 As String , Byval Lcd1 As String , Byval Lcd2 As String )
' Nummer Auf Ab
Declare Sub Nr_auf_ab(byref Nr_parameter As Byte , Byval Nr_step As Byte , Byval Nr_pmax As Byte , Byval Nr_pmin As Byte , Byval Nt_trx As String)
' Step auf ab
Declare Sub Step_auf_ab(byref Step_parameter As Word , Byval Step_step As Word , Byval Step_pmax As Word , Byval Step_pmin As Word , Byval Step_trx As String , Byval Step_einheit As String)
' Step Referenz Einstellung
Declare Sub Step_einstellung(byref Stepxfaktor As Byte , Byref Stepxkhz As Word , Byval Stepxtrx As String , Byval Step__einheit As String)
'*******************************************************************************
'*   Allgemeine Variablen                                                      *
'*******************************************************************************
Dim Ok_cnt As Word                                          ' Zhler fr OK Taste wenn lnger gedrckt
Dim Plus As Byte                                            ' Plus-Flag
Dim Minus As Byte                                           ' Minus Flas
Dim Ok As Byte                                              ' OK 1 OK 2 wenn lang gedrckt
Dim Passt as Byte                                           ' Fram doppel lese vergleich

Dim Pca_addr As Byte                                        ' PCA-Adresse
Dim Pca_port As Byte                                        ' Port Nummer beginnend bei 1 wie TRX Nummer
Dim Pcaschalter As Byte                                     ' Echter Schalter = 1 << 2^PCA_Port

Dim Pcf_nr As Byte                                          ' Expander nummer

Dim I As Byte                                               ' universelle Zhler
Dim J As Word
Dim K As Byte
Dim L As Byte
Dim M As Byte

Dim Restart As Byte                                         ' Ausstieg aus Menues
Dim Bit_byte As Byte                                        ' Byte-Bit Umwandlung

Dim C_position As Byte                                      ' Cursor Position

Dim Temp As Byte                                            ' Temp Byte
Dim Temp_w As Word                                          ' Temp Word
Dim Temp_step As Word
Dim Text_tmp As String * 16                                 ' LCD Speicher
Dim Text_tmp1 As String * 16                                ' LCD Speicher
Dim Parameter_temp As Dword                                 ' Variablen fr 32bit Berechnungen
Dim Parameter_temp1 As Dword
Dim Faktor_temp As Byte
Dim RX_Faktor As Byte                                       ' Temp Byte

Dim Pcf_addr(3) As Byte                                     ' PCF-Addressen
Dim Pcf_dat(3) As Byte                                      ' PCF-Daten

Dim Rel_dat(13) As Byte
Dim Rel_send_dat(2) As Byte
Dim Rel_lese_dat(4) As Byte                                 ' Nur die ersten beiden Bytes haben Daten

Dim Sda_scl_pc As Word                                      ' Leitung tot Zhler

Dim Menueebene As Byte
Dim Hmenuenr As Byte
Dim Rxmenuenr As Byte
Dim Txmenuenr As Byte
Dim Sysmenuenr As Byte
Dim Schmenuenr As Byte
Dim Pcfmenuenr As Byte
Dim Relmenuenr As Byte
Dim Osdmenuenr As Byte

Dim Zeilenarray(15) As String *16                           ' Menue Text Speicher
Dim Zeile As String * 8                                     ' Menuezeile
Dim Zeichen As String * 1                                   ' Zeichen speicher
Dim Twi_fehler_cnt As Word                                  ' TWI Fehlerzhler
Dim Fram_timer_cnt As Word                                  ' Timer Zhler
Dim Fram_timer_flag As Bit                                  ' Timer Flag
Dim Fram_timer_enable as Bit                                ' Timer enable
Dim Menue_timer_cnt As Word                                 ' Timer Zhler
Dim Menue_timer_flag As Bit                                 ' Timer Flag
Dim Refresh As Byte                                         ' Anzeige neu schreiben
'++++++++++++++++++
'+ Daten im Fram: +
'++++++++++++++++++
' Empfnger Datensatz
' 0  RX Adresse    | =0 Ab 0 weden Variablen im FRAM gespeichert
' 1  Hi SP PLL     | LCxxxx PLL in Maspro-Tuner pll - 1856  479,488 MHz abgezogen (12kHz zuwenig !!!!)
' 2  Lo SP PLL     | Teilerfaktor in 256kHz Schritten bei anderer PLL anders ...
'                    Gltig zwischen  900MHz und 2050MHz = 5368 bis 9881
'    Ab hier neue Daten Frequenzangabennur noch in kHz, bzw Tontrger in 10 kHz
' 3  Byte0 XX PLL  | Frequenzangabe in kHz
' 4  Byte1 XX PLL  |
' 5  Byte2 XX PLL  | von 500.000kHz bis 3.000.000kHz
' 6  Byte3 XX PLL  |
' 7  Step_Lo       | Schrittweite je nach PLL in kHz
' 8  Step_Hi       | von 1kHz bis 65535   kHz
' 9  Step_Faktor   | Schrittweiten Faktor 1-10
' 10 Lo TT PLL     | in 10kHz 500 = 5Mhz 775 = 7,75Mhz
' 11 Hi TT PLL     | von 500 bis 1000
' 12 Pos_Neg Video |
' 13 Lo RX LO      | LO in MHz  0 bis 47000
' 14 Hi RX LO      |
' 15 0+-Lo         | Einstellung 0=0, 1=LO + RX_QRG, 2=LO - RX_QRG
' 16 Flags
'    Lock_bit  Alias Flags.0       Lockbit An/Aus
'    Lcd_o_i   Alias Flags.1       LCD An/Aus    0/1
'    Lcd_dauer Alias Flags.2       LCD Dauer An  2
'    Use_Fram  Alias Flags.3       Framnutzung ein aus
'    Rx_o_i    Alias Flags.4       RX an aus
' 17 RX-Typ        | 1=alt  2=alt + M8  3=neu + M8

Dim Twi_rx_buff(18) As Byte
Dim Rx_addr As Byte At Twi_rx_buff Overlay                  ' Adresse des ersten Bytes im Fram
Dim Rx_pll As Word At Twi_rx_buff + 1 Overlay
' Neue Daten
Dim Rx_qrg As Dword At Twi_rx_buff + 3 Overlay
Dim Rx_qrg_step As Word At Twi_rx_buff + 7 Overlay
Dim Rx_faktor_step As Byte At Twi_rx_buff + 9 Overlay
Dim Rx_tt As Word At Twi_rx_buff + 10 Overlay
Dim Rx_vid_pos_neg As Byte At Twi_rx_buff + 12 Overlay
Dim Rx_lo As Word At Twi_rx_buff + 13 Overlay
Dim Rx_lo_p_m As Byte At Twi_rx_buff + 15 Overlay
Dim Rx_flags As Byte At Twi_rx_buff + 16 Overlay
Rx_lock_bit Alias Rx_flags.0
Rx_lcd_o_i Alias Rx_flags.1
Rx_lcd_dauer Alias Rx_flags.2
Rx_use_fram Alias Rx_flags.3
Rx_o_i Alias Rx_flags.4
Dim Rx_typ As Byte At Twi_rx_buff + 17 Overlay

' Temp Lese Variablen fr Prfung
Dim Twi_rx_buff_t(18) As Byte
Dim T_rx_addr As Byte At Twi_rx_buff_t Overlay              ' Adresse des ersten Bytes im Fram
Dim T_rx_pll As Word At Twi_rx_buff_t + 1 Overlay
Dim T_rx_qrg As Dword At Twi_rx_buff_t + 3 Overlay
Dim T_rx_qrg_step As Word At Twi_rx_buff_t + 7 Overlay
Dim T_rx_faktor_step As Byte At Twi_rx_buff_t + 9 Overlay
Dim T_rx_tt As Word At Twi_rx_buff_t + 10 Overlay
Dim T_rx_vid_pos_neg As Byte At Twi_rx_buff_t + 12 Overlay
Dim T_rx_lo As Word At Twi_rx_buff_t + 13 Overlay
Dim T_rx_lo_p_m As Byte At Twi_rx_buff_t + 15 Overlay
Dim T_rx_flags As Byte At Twi_rx_buff_t + 16 Overlay
T_rx_lock_bit Alias T_rx_flags.0
T_rx_lcd_o_i Alias T_rx_flags.1
T_rx_lcd_dauer Alias T_rx_flags.2
T_rx_use_fram Alias T_rx_flags.3
T_rx_o_i Alias T_Rx_flags.4
Dim T_rx_typ As Byte At Twi_rx_buff_t + 17 Overlay
' Temp2 Lese Variablen fr Prfung
Dim Twi_rx_buff_t2(18) As Byte
Dim T2_rx_addr As Byte At Twi_rx_buff_t2 Overlay              ' Adresse des ersten Bytes im Fram
Dim T2_rx_pll As Word At Twi_rx_buff_t2 + 1 Overlay
Dim T2_rx_qrg As Dword At Twi_rx_buff_t2 + 3 Overlay
Dim T2_rx_qrg_step As Word At Twi_rx_buff_t2 + 7 Overlay
Dim T2_rx_faktor_step As Byte At Twi_rx_buff_t2 + 9 Overlay
Dim T2_rx_tt As Word At Twi_rx_buff_t2 + 10 Overlay
Dim T2_rx_vid_pos_neg As Byte At Twi_rx_buff_t2 + 12 Overlay
Dim T2_rx_lo As Word At Twi_rx_buff_t2 + 13 Overlay
Dim T2_rx_lo_p_m As Byte At Twi_rx_buff_t2 + 15 Overlay
Dim T2_rx_flags As Byte At Twi_rx_buff_t2 + 16 Overlay
T2_rx_lock_bit Alias T2_rx_flags.0
T2_rx_lcd_o_i Alias T2_rx_flags.1
T2_rx_lcd_dauer Alias T2_rx_flags.2
T2_rx_use_fram Alias T2_rx_flags.3
T2_rx_o_i Alias T2_Rx_flags.4
Dim T2_rx_typ As Byte At Twi_rx_buff_t2 + 17 Overlay
' Feststehend:
Rx_addr = 0
T_rx_addr = 0
T2_rx_addr = 0

' Sender Datensatz
' 0  TX Adresse     | =100 Ab 0 weden Variablen im FRAM gespeichert
' 1  Hi SP PLL      | SP5055 in 125kHz Schritten
' 2  Lo SP PLL      | Teilerfaktor   von 4000 bis 21200
' 3  Lo TT PLL      | MB1501 LO= 27MHz  F=TT+LO
' 4  Hi TT PLL      | Teilerfaktor   von 32000 bis 36000
' 5  PTT            | PTT Zustand
' 6  VAGC           | Video-AGC-Zustand
' 7  PLL NA ERR     | PLL Fehler speicher
' 8  EE-Daten       | Konfiguration des Einschubs
'    Use_FRam Alias EE_Daten.0  Framnutzung ein aus
'    Use_Lock Alias EE_Daten.1  Lock-Bitnutzung ein aus
'    Use_PLL  Alias EE_Daten.2  PLLnutzung ein aus
' Ab hier neue Daten Frequenzangabennur noch in kHz, bzw Tontrger in10 kHz
' 9  Byte0 XX PLL   | Frequenzangabe kHz
' 10 Byte1 XX PLL   |
' 11 Byte2 XX PLL   | von 500.000kHz bis 3.000.000kHz
' 12 Byte3 XX PLL   |
' 13 Step_Lo        | in kHz
' 14 Step_Hi        | von 1kHz bis 65535   kHz
' 15 Step_Faktor    | Schrittweiten Faktor1-10
' 16 Lo TT QRG      | in 10kHz 500 = 5Mhz 775 = 7,75Mhz
' 17 Hi TT QRG      | von 500 bis 1000
' 18 Pos_Neg Video  |
' 19 Lo TX LO       | LO in MHz (TX-Mischer)
' 20 Hi TX LO       | 0 bis 47000
' 21 0+-Lo          | Einstellung 0=0, 1=LO + RX_QRG, 2=LO - RX_QRG
' 22 Vervielfachung | Bei nutzung eines Verfielfachers  1 - 10
' 23 TX-Typ         | 1=alt 2=neu
Dim Twi_tx_buff(24) As Byte                                 ' TWI Sende bytes
Dim Tx_addr As Byte At Twi_tx_buff Overlay                  ' Adresse des ersten Bytes im Fram
Dim Tx_pll As Word At Twi_tx_buff + 1 Overlay
Dim Tx_tt_pll As Word At Twi_tx_buff + 3 Overlay
Dim Tx_ptt As Byte At Twi_tx_buff + 5 Overlay
Dim Tx_vagc As Byte At Twi_tx_buff + 6 Overlay
Dim Tx_pll_na_err As Byte At Twi_tx_buff + 7 Overlay
Dim Tx_pll_ee_daten As Byte At Twi_tx_buff + 8 Overlay
Tx_use_fram Alias Tx_pll_ee_daten.0
Tx_use_lock Alias Tx_pll_ee_daten.1
Tx_use_pll Alias Tx_pll_ee_daten.2
'neue Daten
Dim Tx_qrg As Dword At Twi_tx_buff + 9 Overlay
Dim Tx_qrg_step As Word At Twi_tx_buff + 13 Overlay
Dim Tx_faktor_step As Byte At Twi_tx_buff + 15 Overlay
Dim Tx_tt As Word At Twi_tx_buff + 16 Overlay
Dim Tx_vid_pos_neg As Byte At Twi_tx_buff + 18 Overlay
Dim Tx_lo As Word At Twi_tx_buff + 19 Overlay
Dim Tx_lo_p_m As Byte At Twi_tx_buff + 21 Overlay
Dim Tx_faktor As Byte At Twi_tx_buff + 22 Overlay
Dim Tx_typ As Byte At Twi_tx_buff + 23 Overlay

' Temp Lese Variablen fr Prfung
Dim Twi_tx_buff_t(24) As Byte                               ' TWI Sende bytes
Dim T_tx_addr As Byte At Twi_tx_buff_t Overlay              ' Adresse des ersten Bytes im Fram
Dim T_tx_pll As Word At Twi_tx_buff_t + 1 Overlay
Dim T_tx_tt_pll As Word At Twi_tx_buff_t + 3 Overlay
Dim T_tx_ptt As Byte At Twi_tx_buff_t + 5 Overlay
Dim T_tx_vagc As Byte At Twi_tx_buff_t + 6 Overlay
Dim T_tx_pll_na_err As Byte At Twi_tx_buff_t + 7 Overlay
Dim T_tx_pll_ee_daten As Byte At Twi_tx_buff_t + 8 Overlay
T_tx_use_fram Alias T_tx_pll_ee_daten.0
T_tx_use_lock Alias T_tx_pll_ee_daten.1
T_tx_use_pll Alias T_tx_pll_ee_daten.2
'neue Daten
Dim T_tx_qrg As Dword At Twi_tx_buff_t + 9 Overlay
Dim T_tx_qrg_step As Word At Twi_tx_buff_t + 13 Overlay
Dim T_tx_faktor_step As Byte At Twi_tx_buff_t + 15 Overlay
Dim T_tx_tt As Word At Twi_tx_buff_t + 16 Overlay
Dim T_tx_vid_pos_neg As Byte At Twi_tx_buff_t + 18 Overlay
Dim T_tx_lo As Word At Twi_tx_buff_t + 19 Overlay
Dim T_tx_lo_p_m As Byte At Twi_tx_buff_t + 21 Overlay
Dim T_tx_faktor As Byte At Twi_tx_buff_t + 22 Overlay
Dim T_tx_typ As Byte At Twi_tx_buff_t + 23 Overlay

' Temp2 Lese Variablen fr Prfung
Dim Twi_tx_buff_t2(24) As Byte                               ' TWI Sende bytes
Dim T2_tx_addr As Byte At Twi_tx_buff_t2 Overlay              ' Adresse des ersten Bytes im Fram
Dim T2_tx_pll As Word At Twi_tx_buff_t2 + 1 Overlay
Dim T2_tx_tt_pll As Word At Twi_tx_buff_t2 + 3 Overlay
Dim T2_tx_ptt As Byte At Twi_tx_buff_t2 + 5 Overlay
Dim T2_tx_vagc As Byte At Twi_tx_buff_t2 + 6 Overlay
Dim T2_tx_pll_na_err As Byte At Twi_tx_buff_t2 + 7 Overlay
Dim T2_tx_pll_ee_daten As Byte At Twi_tx_buff_t2 + 8 Overlay
T2_tx_use_fram Alias T2_tx_pll_ee_daten.0
T2_tx_use_lock Alias T2_tx_pll_ee_daten.1
T2_tx_use_pll Alias T2_tx_pll_ee_daten.2
'neue Daten
Dim T2_tx_qrg As Dword At Twi_tx_buff_t2 + 9 Overlay
Dim T2_tx_qrg_step As Word At Twi_tx_buff_t2 + 13 Overlay
Dim T2_tx_faktor_step As Byte At Twi_tx_buff_t2 + 15 Overlay
Dim T2_tx_tt As Word At Twi_tx_buff_t2 + 16 Overlay
Dim T2_tx_vid_pos_neg As Byte At Twi_tx_buff_t2 + 18 Overlay
Dim T2_tx_lo As Word At Twi_tx_buff_t2 + 19 Overlay
Dim T2_tx_lo_p_m As Byte At Twi_tx_buff_t2 + 21 Overlay
Dim T2_tx_faktor As Byte At Twi_tx_buff_t2 + 22 Overlay
Dim T2_tx_typ As Byte At Twi_tx_buff_t2 + 23 Overlay

' Feststehend:
Tx_addr = 100
T_tx_addr = 100
T2_tx_addr = 100

' OSD-Datensatz
' das ber das OSD-Ausgegebene Call bei der Feldstrke ist maximal 8-Stellig
Dim Osd_addr As Byte
Dim Osd_call As String * 8 At Osd_addr + 1 Overlay          ' 8 Zeichen fr Call
Osd_addr = 180                                              ' Befehl zum Call speichern

'*******************************************************************************
'*   Konstanten                                                                *
'*******************************************************************************
Const Qrg = "QRG"
Const Steps = "Step"
Const Ttqrg = "TT-QRG"
Const Nummer = "Nr"
Const Lockbit = "L-Bit"
Const Rx = "RX "
Const Tx = "TX "
Const System = "System"
Const Lo = "Lo QRG"
Const Lo_p_n = "Lo +0-"
Const Agc = "AGC "
Const Ptt = "PTT"
Const Pll_0_1 = "PLL 0/1"
Const Rx_0_1 = "RX 0/1"
Const Mfaktor = "Faktor"
Const Zf = "ZF"
Const Dauer = "Dauer"
Const Pcaaddr = "PCA-Adr"
Const Video = "Video"
Const Leer = " "
Const Ein = "Ein"
Const Aus = "Aus"
Const Pos = "Pos"
Const Nega = "Neg"
Const Ufram = "UseFr"
Const Mhz = "Mhz"
Const Khz = "khz"
Const X_typ = "Typ"
Const Schalter = "Schalter"
Const Pcf = "PCF"
Const Sch_name = "Sch_name"
Const Osd = "OSD Call"
Const Rel = "REL"
Const Rel_name = "REL_name"
Const Mexit = "Exit"
Const Hmenuemax = 3
Const Rxmenuemax = 12
Const Txmenuemax = 15
Const Sysmenuemax = 7
Const Schmenuemax = 9
Const Pcfmenuemax = 4
Const Relmenuemax = 13
Const Osdmenuemax = 9

Const Versuche = 15                                         ' Anzahl der maximalen Fehlversuche den IC-Bus zu bedienen
Const Fram_addr = 160                                       ' I2C-Adresse (160)

Const Menue_timeout = 1000                                  ' 255*1024/8MHz=32,64ms  33ms* 1000= 30s
Const Fram_timeout = 30                                     ' 255*1024/8MHz=32,64ms  33ms* 30= 3s

Const Pcf1_addr = 72                                        ' Adresse der einzelnen Expander
Const Pcf2_addr = 68                                        '
Const Pcf3_addr = 66
Const Rel_addr = &H66                                       ' 102 Relaisbox
const Osd_ctrl_addr = 96
'*******************************************************************************
'*   Initialisierung                                                           *
'*******************************************************************************

Init:
   Gosub Tasten_pause
   Gosub Tasten_pause
   Gosub Tasten_pause
   Cls                                                      ' Clear LCD screen
   Lcd Titel                                                ' Was zum lesen
   Lowerline
   Lcd Versionsnummer
   'Print Titel
   'Print Versionsnummer
   Readeeprom Rx_pll , 0
   Readeeprom Rx_qrg , 2
   Readeeprom Rx_qrg_step , 6
   Readeeprom Rx_faktor_step , 8
   Readeeprom Rx_tt , 9
   Readeeprom Rx_vid_pos_neg , 11
   Readeeprom Rx_lo , 12
   Readeeprom Rx_lo_p_m , 14
   Readeeprom Rx_flags , 15
   Readeeprom Rx_typ , 16
   Readeeprom Tx_pll , 17
   Readeeprom Tx_tt_pll , 19
   Readeeprom Tx_ptt , 21
   Readeeprom Tx_vagc , 22
   Readeeprom Tx_pll_na_err , 23
   Readeeprom Tx_pll_ee_daten , 24
   Readeeprom Tx_qrg , 25
   Readeeprom Tx_qrg_step , 29
   Readeeprom Tx_faktor_step , 31
   Readeeprom Tx_tt , 32
   Readeeprom Tx_vid_pos_neg , 34
   Readeeprom Tx_lo , 35
   Readeeprom Tx_lo_p_m , 37
   Readeeprom Tx_faktor , 38
   Readeeprom Tx_typ , 39
   Readeeprom Pca_addr , 40
   'Readeeprom Hmenuenr , 41
   Pca_0 = Pca_addr.1                                       ' Stelle die PCA-Adresse ein
   Pca_1 = Pca_addr.2
   Pca_2 = Pca_addr.3

   Menue_timer_cnt = Menue_timeout
   Fram_timer_cnt = Fram_timeout
   Pcf_addr(1) = Pcf1_addr
   Pcf_addr(2) = Pcf2_addr
   Pcf_addr(3) = Pcf3_addr
   Hmenuenr = 1
   Menueebene = 1
   Rxmenuenr = 1
   Txmenuenr = 1
   Sysmenuenr = 1
   Schmenuenr = 1
   Pcfmenuenr = 1
   Relmenuenr = 1
   Osdmenuenr = 1
   Pcf_nr = 1
   Pca_port = 1
   Pca_r = 1
   Restart = 0
   Cursor Off Noblink
   Wait 1
   Cls
   Enable Timer0                                           ' schalte den Timer0 Overflow Interrupt Ein
   Enable Timer2                                           ' schalte den Timer1 Overflow Interrupt Ein
   Enable Interrupts
   '*******************************************************************************
   '*   MenueStruktur                                                             *
   '*******************************************************************************
Menu_routine:
   Do
      Select Case Menueebene
         Case 1                                                   ' Menueebene
            Gosub Haupt_menue_fuellen
            Call Menue(hmenuenr , Hmenuemax)
            Menueebene = 2
         Case 2                                                   ' Menueebene
            Select Case Hmenuenr
               Case 1
                  Gosub Rx_menue_fuellen
                  Call Menue(rxmenuenr , Rxmenuemax)
                  Menueebene = 3
               Case 2
                  Gosub Tx_menue_fuellen
                  Call Menue(txmenuenr , Txmenuemax)
                  Menueebene = 3
               Case 3
                  Gosub Sys_menue_fuellen
                  Call Menue(sysmenuenr , Sysmenuemax)
                  Menueebene = 3
            End Select                                             ' Hmenuenr
         Case 3                                                   ' Menueebene
            Menueebene = 2
            Select Case Hmenuenr
               Case 1
                  Gosub Trx_fram_lesen
                  Select Case Rxmenuenr                              ' Menues Ausfhren
                     Case 1                                             ' RX Nummer
                        Text_tmp = Rx + Leer
                        Text_tmp = Text_tmp + Str(Pca_port)
                        Call Nr_auf_ab(pca_port , 1 , 8 , 1 , Text_tmp)
                        Gosub Trx_fram_lesen
                     Case 2                                             ' RX QRG
                        Faktor_temp = 1
                        Fram_timer_enable = 1                           ' Fram periodisch lesen
                        Text_tmp = Rx + Leer
                        Text_tmp = Text_tmp + Str(Pca_port)
                        RX_Faktor = 1
                        Call Auf_ab(rx_qrg , Rx_qrg_step , Rx_faktor_step , RX_Faktor , Rx_lo_p_m , Rx_lo , 4000000 , 250000 , Text_tmp )
                        Fram_timer_enable = 0                           ' Fram periodisch lesen
                     Case 3                                             ' RX Step
                        Text_tmp = Steps + RX
                        Text_tmp = Text_tmp +  Str(Pca_port)
                        Call Step_einstellung(rx_faktor_step , Rx_qrg_step , Text_tmp , Khz)
                     Case 4                                             ' RX Tontrger
                        Text_tmp = "0" + Khz
                        Text_tmp1 = Ttqrg + Str(Pca_port)
                        Call Step_auf_ab(rx_tt , 1 , 1000 , 500 , Text_tmp1 , Text_tmp)
                     Case 5                                             ' RX Video pos neg
                        Text_tmp = Video + Leer
                        Text_tmp = Text_tmp + Str(Pca_port)
                        Bit_byte = Rx_vid_pos_neg
                        Call Bit_ein_aus(bit_byte , Text_tmp , 1 , Pos , Nega , "")
                        Rx_vid_pos_neg = Bit_byte
                        Gosub Trx_fram_schreiben
                     Case 6                                             ' RX ZF bzw. LO
                        Text_tmp = Lo + Leer
                        Text_tmp = Text_tmp + Str(Pca_port)
                        Call Step_auf_ab(rx_lo , 1 , 47000 , 0 , Text_tmp , Mhz)
                     Case 7                                             ' RX Lo + - 0
                        Text_tmp = Lo_p_n + Leer
                        Text_tmp = Text_tmp + Str(Pca_port)
                        Bit_byte = Rx_lo_p_m
                        Call Bit_ein_aus(bit_byte , Text_tmp , 2 , "0" , "+" , "-")
                        Rx_lo_p_m = Bit_byte
                        Gosub Trx_fram_schreiben
                     Case 8                                             ' RX Lock Bit An / Aus
                        Text_tmp = Lockbit + Leer
                        Text_tmp = Text_tmp + Str(Pca_port)
                        Bit_byte = Rx_lock_bit
                        Call Bit_ein_aus(bit_byte , Text_tmp , 1 , Aus , Ein , "")
                        Rx_lock_bit = Bit_byte.0
                        Gosub Trx_fram_schreiben
                     Case 9                                             ' RX PLL An / Aus
                        Text_tmp = Ufram + Leer
                        Text_tmp = Text_tmp + Str(Pca_port)
                        Bit_byte = Rx_use_fram
                        Call Bit_ein_aus(bit_byte , Text_tmp , 1 , Aus , Ein , "")
                        Rx_use_fram = Bit_byte.0
                        Gosub Trx_fram_schreiben
                     Case 10                                            ' RX An / Aus
                        Text_tmp = Rx_0_1 + Leer
                        Text_tmp = Text_tmp + Str(Pca_port)
                        Bit_byte = Rx_o_i
                        Call Bit_ein_aus(bit_byte , Text_tmp , 1 , Aus , Ein , "")
                        Rx_o_i = Bit_byte.0
                        Gosub Trx_fram_schreiben
                     Case 11                                            ' RX Typ
                        Text_tmp = Rx + X_typ
                        Text_tmp = Text_tmp + Str(Pca_port)
                        Bit_byte = Rx_typ
                        Call Nr_auf_ab(bit_byte , 1 , 3 , 1 , Text_tmp)
                        If RX_Typ <> Bit_byte Then
                           Select case Bit_Byte
                              case 1 TO 2
                                 Rx_pll = 6561
                                 Rx_qrg = 1200128
                                 Rx_qrg_step = 256
                              case 3
                                 Rx_pll = 13436
                                 Rx_qrg = 1200000
                                 Rx_qrg_step = 125
                           end select
                        end if
                        Rx_typ = Bit_byte
                        Gosub Trx_fram_schreiben
                     Case Rxmenuemax
                        Menueebene = 1
                  End Select
               Case 2
                  Gosub Trx_fram_lesen
                  Gosub Trx_fram_lesen
                  Select Case Txmenuenr
                     Case 1                                             ' TX Nummer
                        Text_tmp = Tx + Leer
                        Text_tmp = Text_tmp + Str(Pca_port)
                        Call Nr_auf_ab(pca_port , 1 , 8 , 1 , Text_tmp)
                        Gosub Trx_fram_lesen
                     Case 2                                             ' TX QRG
                        Fram_timer_enable = 1                           ' Fram periodisch lesen
                        Text_tmp = Tx + Leer
                        Text_tmp = Text_tmp + Str(Pca_port)
                        Call Auf_ab(tx_qrg , Tx_qrg_step , Tx_faktor_step , Tx_faktor , Tx_lo_p_m , Tx_lo , 4000000 , 250000 , Text_tmp)
                        Fram_timer_enable = 0                           ' Fram periodisch lesen
                     Case 3                                             ' TX Schrittweite
                        Text_tmp = Steps + TX
                        Text_tmp = Text_tmp +  Str(Pca_port)
                        Call Step_einstellung(tx_faktor_step , Tx_qrg_step , Text_tmp , Khz)
                        Gosub Trx_fram_schreiben
                     Case 4                                             ' TX Tontrger
                        Text_tmp = "0" + Khz
                        Text_tmp1 = Ttqrg + Str(Pca_port)
                        Call Step_auf_ab(tx_tt , 1 , 1000 , 500 , Text_tmp1 , Text_tmp)
                     Case 5                                             ' TX Video pos neg
                        Text_tmp = Video + Leer
                        Text_tmp = Text_tmp + Str(Pca_port)
                        Bit_byte = Tx_vid_pos_neg
                        Call Bit_ein_aus(bit_byte , Text_tmp , 1 , Pos , Nega , "")
                        Tx_vid_pos_neg = Bit_byte
                        Gosub Trx_fram_schreiben
                     Case 6                                             ' TX ZF bzw Lo
                        Text_tmp = Lo + Leer
                        Text_tmp = Text_tmp + Str(Pca_port)
                        Call Step_auf_ab(tx_lo , 1 , 47000 , 0 , text_tmp , Mhz)
                     Case 7                                             ' TX Lo _0 + -
                        Text_tmp = Lo_p_n + Leer
                        Text_tmp = Text_tmp + Str(Pca_port)
                        Bit_byte = Tx_lo_p_m
                        Call Bit_ein_aus(bit_byte , Text_tmp , 2 , "0" , "+" , "-")
                        Tx_lo_p_m = Bit_byte
                        Gosub Trx_fram_schreiben
                     Case 8                                             ' TX Faktor
                        Text_tmp = Mfaktor + Leer
                        Text_tmp = Text_tmp + Str(Pca_port)
                        Call Nr_auf_ab(tx_faktor , 1 , 10 , 1 , Text_tmp)
                        Gosub Trx_fram_schreiben
                     Case 9                                             ' TX PTT An / Aus
                        Text_tmp = Ptt + Leer
                        Text_tmp = Text_tmp + Str(Pca_port)
                        Bit_byte = Tx_ptt
                        Call Bit_ein_aus(bit_byte , Text_tmp , 1 , Aus , Ein , "")
                        Tx_ptt = Bit_byte
                        Gosub Trx_fram_schreiben
                     Case 10                                            ' TX Video Agc An / Aus
                        Text_tmp = Agc + Leer
                        Text_tmp = Text_tmp + Str(Pca_port)
                        Bit_byte = Tx_vagc.0
                        Call Bit_ein_aus(bit_byte , Text_tmp , 1 , Aus , Ein , "")
                        Tx_vagc.0 = Bit_byte.0
                        Gosub Trx_fram_schreiben
                     Case 11                                            ' TX Lock bit An / Aus
                        Text_tmp = Lockbit + Leer
                        Text_tmp = Text_tmp + Str(Pca_port)
                        Bit_byte = Tx_use_lock
                        Call Bit_ein_aus(bit_byte , Text_tmp , 1 , Aus , Ein , "")
                        Tx_use_lock = Bit_byte.0
                        Gosub Trx_fram_schreiben
                     Case 12                                            ' TX PLL An / Aus
                        Text_tmp = Pll_0_1 + Leer
                        Text_tmp = Text_tmp + Str(Pca_port)
                        Bit_byte = Tx_use_pll
                        Call Bit_ein_aus(bit_byte , Text_tmp , 1 , Aus , Ein , "")
                        Tx_use_pll = Bit_byte.0
                        Gosub Trx_fram_schreiben
                     Case 13                                            ' TX PLL An / Aus
                        Text_tmp = Ufram + Leer
                        Text_tmp = Text_tmp + Str(Pca_port)
                        Bit_byte = Tx_use_fram
                        Call Bit_ein_aus(bit_byte , Text_tmp , 1 , Aus , Ein , "")
                        Bit_byte = Bit_byte
                        Tx_use_fram = Bit_byte.0
                        Gosub Trx_fram_schreiben
                     Case 14                                            ' TX Typ
                        Text_tmp = Tx + X_typ
                        Text_tmp = Text_tmp + Str(Pca_port)
                        Bit_byte = Tx_typ
                        Call Nr_auf_ab(bit_byte , 1 , 3 , 1 , Text_tmp)
                        If TX_Typ <> Bit_byte Then
                           Tx_pll = 9600
                           Tx_qrg = 1200000
                           Tx_qrg_step = 125
                        end if
                        Tx_typ = Bit_byte
                        Gosub Trx_fram_schreiben
                     Case Txmenuemax
                        Menueebene = 1
                  End Select
               Case 3                                                 ' HMenuenummer
                  Select Case Sysmenuenr
                     Case 1                                             ' PCA-Adresse festlegen
                        Gosub M_pca_addr
                     Case 2                                             ' PCF8574  einstellen
                        Gosub Schalter_menue_fuellen
                        Call Menue(pcfmenuenr , Pcfmenuemax)            ' PCF auswhlen
                        Menueebene = 4
                     Case 3                                             ' PCF Schalter Namen auswhlem
                        Gosub Schalter_menue_fuellen
                        Call Menue(pcfmenuenr , Pcfmenuemax)            ' PCF auswhlen
                        Menueebene = 4
                     Case 4                                             ' Relais auswhlen
                        Gosub Rel_menue_fuellen
                        Call Menue(relmenuenr , Relmenuemax)            ' Einen Schalternamen der PCF auswhlen
                        Menueebene = 4
                     Case 5                                             ' Relais-Namen auswhlem
                        Gosub Rel_menue_fuellen
                        Call Menue(relmenuenr , Relmenuemax)            ' Einen Schalternamen der PCF auswhlen
                        Menueebene = 4
                     Case 6                                             ' OSD-Call einstellen
                        Gosub Osd_menue_fuellen
                        Call Menue(osdmenuenr , Osdmenuemax)            ' Einen Schalternamen der PCF auswhlen
                        Menueebene = 4
                     Case Sysmenuemax
                        Menueebene = 1
                  End Select                                         ' Sysmenue
            End Select                                             ' Hmenue
         Case 4                                                   ' Menueebene
            Menueebene = 3
            Select Case Hmenuenr
               'Case 1 'RX Menue
               'Case 2 'TX_Menue
               Case 3                                             ' Sys Menue
                  Select Case Sysmenuenr
                     'Case 1
                     Case 2
                        Select Case Pcfmenuenr
                           Case 1 To 3                                  ' Einen der PCF einstellen
                              Pcf_nr = Pcfmenuenr
                              Gosub Pcf_menue_fuellen
                              Call Menue(schmenuenr , Schmenuemax)      ' Einen Schalter der PCF auswhlen
                              Menueebene = 5
                           Case Pcfmenuemax
                              Menueebene = 2
                        End Select
                     Case 3
                        Select Case Pcfmenuenr
                           Case 1 To 3                                  ' Einen der PCF einstellen
                              Pcf_nr = Pcfmenuenr
                              Gosub Pcf_menue_fuellen
                              Call Menue(schmenuenr , Schmenuemax)      ' Einen Schalternamen der PCF auswhlen
                              Menueebene = 5
                           Case Pcfmenuemax
                              Menueebene = 2
                        End Select
                     Case 4                                          ' Relais-Schalten
                        Select Case Relmenuenr
                           Case 1 To 12                                 ' Schalter umschalten
                              Gosub Rel_lesen
                              Text_tmp =  Zeilenarray(relmenuenr) + Leer
                              Text_tmp = Text_tmp + Str(Pca_port)
                              Bit_byte = Rel_dat(relmenuenr)
                              Call Bit_ein_aus(bit_byte , Text_tmp , 1 , Aus , Ein , "")
                              Rel_dat(relmenuenr) = Bit_byte.0
                              Gosub Rel_schreiben
                           Case Relmenuemax
                              Menueebene = 2
                        End Select
                     Case 5                                          ' Relais-Namen Editieren
                        Select Case Relmenuenr
                           Case 1 To 12                                 ' Relais Namen ndern
                              Gosub Edit_name_relais
                           Case Relmenuemax
                              Menueebene = 2
                        End Select
                     Case 6                                          ' OSD-Call Editieren
                        Select Case Osdmenuenr
                           Case 1 To 8                                  ' Call ndern
                              Pcf_nr = Osdmenuenr
                              Gosub Edit_call
                           Case Osdmenuemax
                              Menueebene = 2
                        End Select
                  End Select                                      ' sys Menu
            End Select                                         ' hmenue
         Case 5                                                   ' menueebene
            Menueebene = 4
            Select Case Hmenuenr
               'Case 1 'RX Menue
               'Case 2 'TX_Menue
               Case 3                                                 ' Sys Menue
                  Select Case Sysmenuenr
                     'Case 1
                     Case 2                                             ' Schalter menue
                        Select Case Schmenuenr
                           Case 1 To 8                                  ' Schalter umschalten
                              Gosub Pcf_lesen
                              I = Schmenuenr - 1
                              Text_tmp = Zeilenarray(schmenuenr) + Leer
                              Text_tmp = Text_tmp + Str(Pca_port)
                              Bit_byte = Pcf_dat(pcfmenuenr).i
                              Call Bit_ein_aus(bit_byte , Text_tmp , 1 , Aus , Ein , "")
                              Pcf_dat(pcfmenuenr).i = Bit_byte.0
                              Gosub Pcf_schreiben
                           Case Schmenuemax
                              Menueebene = 3
                        End Select
                     Case 3                                             ' Schalter Name
                        Select Case Schmenuenr
                           Case 1 To 8                                  ' Schalter Name ndern
                              Gosub Edit_name_schalter
                           Case Schmenuemax
                              Menueebene = 3
                        End Select
                        'Case 4
                        'Case 5
                        'Case 6
                  End Select                                         ' Sysmenue
            End Select                                             ' Hmenue
      End Select                                               ' Menueebene
      If Restart = 1 Then
         Menueebene = 1
         Restart = 0
      End If
   Loop
   '*******************************************************************************
   '*   Muens fllen                                                             *
   '*******************************************************************************
Haupt_menue_fuellen:
   'Hauptmenue
   Zeilenarray(1) = Rx
   Zeilenarray(2) = Tx
   Zeilenarray(3) = System
Return
Rx_menue_fuellen:
   'RX-Menue
   Text_tmp = "R" + Str(pca_port)
   Zeilenarray(1) = Text_tmp + Nummer
   Zeilenarray(2) = Text_tmp + Qrg
   Zeilenarray(3) = Text_tmp + Steps                     ' Mit kHz Einstellung !!!
   Zeilenarray(4) = Text_tmp + Ttqrg
   Zeilenarray(5) = Text_tmp + Video
   Zeilenarray(6) = Text_tmp + Zf
   Zeilenarray(7) = Text_tmp + Lo_p_n
   Zeilenarray(8) = Text_tmp + Lockbit
   Zeilenarray(9) = Text_tmp + Ufram
   Zeilenarray(10) = Text_tmp + Rx_0_1
   Zeilenarray(11) = Text_tmp + X_typ
   Zeilenarray(12) = Mexit
Return
Tx_menue_fuellen:
   'TX-Menue
   Text_tmp = "T" + Str(pca_port)
   Zeilenarray(1) = Text_tmp + Nummer
   Zeilenarray(2) = Text_tmp + Qrg
   Zeilenarray(3) = Text_tmp + Steps                     ' Mit kHz Einstellung !!!
   Zeilenarray(4) = Text_tmp + Ttqrg
   Zeilenarray(5) = Text_tmp + Video
   Zeilenarray(6) = Text_tmp + Zf
   Zeilenarray(7) = Text_tmp + Lo_p_n
   Zeilenarray(8) = Text_tmp + Mfaktor
   Zeilenarray(9) = Text_tmp + Ptt
   Zeilenarray(10) = Text_tmp + Agc
   Zeilenarray(11) = Text_tmp + Lockbit
   Zeilenarray(12) = Text_tmp + Pll_0_1
   Zeilenarray(13) = Text_tmp + Ufram
   Zeilenarray(14) = Text_tmp + X_typ
   Zeilenarray(15) = Mexit
Return
Sys_menue_fuellen:
   'System-Menue
   Zeilenarray(1) = Pcaaddr
   Zeilenarray(2) = Schalter
   Zeilenarray(3) = Sch_name
   Zeilenarray(4) = Rel
   Zeilenarray(5) = Rel_name
   Zeilenarray(6) = Osd
   Zeilenarray(7) = Mexit
Return
Schalter_menue_fuellen:
   'Schalter-Menue
   Zeilenarray(1) = Pcf + "1"
   Zeilenarray(2) = Pcf + "2"
   Zeilenarray(3) = Pcf + "3"
   Zeilenarray(4) = Mexit
Return
Pcf_menue_fuellen:
   J = Pcf_nr - 1
   J = J * 72                                            ' SCHALT X = 8 Zeichen * 8 Zeilen +8 0-Strings
   J = J + 42                                            ' Offset
   For I = 1 To 8
      Readeeprom Zeile , J
      Zeilenarray(i) = Zeile
      J = J + 9
   Next
   Zeilenarray(9) = Mexit
Return
Rel_menue_fuellen:
   J = 258                                               ' Offset
   For I = 1 To 12
      Readeeprom Zeile , J
      Zeilenarray(i) = Zeile
      J = J + 9
   Next
   Zeilenarray(13) = Mexit
Return
Osd_menue_fuellen:
   For I = 1 To 8
      Zeilenarray(i) = "OSD " + Str(i)
   Next
   Zeilenarray(9) = Mexit
Return
'*******************************************************************************
'*   System-Menu PCA-Adresse einstellen                                        *
'*******************************************************************************
M_pca_addr:
   C_position = 7
   Disable Timer0
   Disable Timer2
   Do
      Cls
      Lcd Pcaaddr
      Locate 2 , 1
      Lcd Bin(pca_addr)
      Locate 2 , C_position                                    ' cursor auf Bit 1,2,3
      Cursor On Blink
      Gosub Tasten_pause
      Gosub Tastaturabfrage
      If Plus = 1 Then
         Decr C_position
         If C_position < 5 Then C_position = 7
      End If
      If Minus = 1 Then
         Temp = 8 - C_position                                 ' entsprechendes Bit berechnen
         Temp = 2 ^ Temp                                       ' Bit-Maske baun
         Pca_addr = Pca_addr Xor Temp                          ' Bit Toggeln
      End If
      If Ok > 0 Or Restart = 1 Then Exit Do                  ' zurck ins System-Menue
   Loop
   If Pca_addr > &B1110_1110 Or Pca_addr < &B1110_0000 Then    ' nochmal prfen
      Pca_addr = &B1110_0000
   End If
   Writeeeprom Pca_addr , 40
   Pca_0 = Pca_addr.1                                          ' Stelle die PCA-Adresse ein
   Pca_1 = Pca_addr.2
   Pca_2 = Pca_addr.3
   Cursor Off Noblink
   Enable Timer0
   Enable Timer2
Return
'*******************************************************************************
'*   Menue Schalternamen editieren                                             *
'*******************************************************************************
Edit_name_schalter:
   Zeile = Zeilenarray(schmenuenr)
   C_position = 1
   Disable Timer0
   Disable Timer2
   Text_tmp = "Schal" + Str(pcfmenuenr)
   Text_tmp = Text_tmp + " "
   Text_tmp = Text_tmp + Str(schmenuenr)
   Gosub Edit_zeile
   'Adressberechnung zum Schreiben des neuen Schalternamens
   I = Schmenuenr - 1                                       ' welcher Schalter
   J = Pcfmenuenr - 1                                       ' welcher PCF
   J = J * 72                                               ' block (8 zeichen + 0String) * 8
   I = I * 9                                                ' I-ter Schalter
   J = J + I
   J = J + 42
   Writeeeprom Zeile , J
   Cursor Off Noblink
   Enable Timer0
   Enable Timer2
Return

Edit_name_relais:
   Zeile = Zeilenarray(relmenuenr)
   C_position = 1
   Disable Timer0
   Disable Timer2
   Text_tmp = "Rel " + Str(relmenuenr)
   Gosub Edit_zeile
   'Adressberechnung zum Schreiben des neuen Relaisnamens
   I = Relmenuenr - 1                                       ' welches Relais
   I = I * 9                                                ' I-tesRelais
   J = I + 258                                              ' Rel Startadresse Eeprom
   Writeeeprom Zeile , J
   Cursor Off Noblink
   Enable Timer0
   Enable Timer2
Return

Edit_call:
   Home
   Lcd "LeseCall"
   waitms 500
   Pca_port = Osdmenuenr
   Gosub Osd_call_lesen
   Zeile = Osd_call
   If Mid(zeile , 1 , 1) = Chr(0) Then
      Zeile = "NO" + Str(osdmenuenr)
      Zeile = Zeile + "CALL "
   End If
   C_position = 1
   Disable Timer0
   Disable Timer2
   Text_tmp = "OSD " + Str(osdmenuenr)
   Gosub Edit_zeile
   Osd_call = Zeile
   Pca_port = Osdmenuenr
   Gosub Osd_call_schreiben
   Cursor Off Noblink
   Enable Timer0
   Enable Timer2
Return

Edit_zeile:
   Do
      Cls
      Lcd Text_tmp
      Locate 2 , 1
      Lcd Zeile
      Locate 2 , C_position                                 ' cursor auf 1,2,3,...8
      Cursor On
      Gosub Tasten_pause
      Gosub Tastaturabfrage
      If Plus = 1 Then
         Incr C_position
         If C_position > 8 Then C_position = 1
      End If
      If Minus = 1 Then
         Decr C_position                                    ' entsprechendes Bit berechnen
         If C_position < 1 Then C_position = 8
      End If
      If Ok = 2 Then
         Ok = 0
         Gosub Edit_bst                                     ' Position edutieren
      End If
      If Ok = 1 Then
         Ok = 0
         Exit Do                                            ' zurck ins PCF-Menue
      End If
   Loop
Return

Edit_bst:
   Zeichen = Mid(zeile , C_position , 1)
   I = Asc(zeichen)
   Cursor On Blink
   Do
      Gosub Tasten_pause
      Gosub Tastaturabfrage
      If Plus = 1 Then
         Incr I                                             ' Buchstabe rauf
         If I > 90 Then I = 32
      End If
      If Minus = 1 Then
         Decr I
         If i < 32 Then I =  90                             ' Buchstabe runter
      End If
      If Ok > 0 Then
         Ok = 0
         Cursor On Noblink
         Exit Do
      End If
      Locate 2 , C_position
      Lcd Chr(i)
      Locate 2 , C_position
      Mid(zeile , C_position , 1) = Chr(i)
   Loop
Return
'*******************************************************************************
'*   Menue Haupt Funktion                                                      *
'*******************************************************************************
Sub Menue(byref Menuenr As Byte , Byval Maxmenue As Byte)
   Mmenue:
      Do
         Cls
         Lcd Zeilenarray(menuenr)
         Lowerline
         If Menuenr = Maxmenue Then
            Temp = 1
         Else
            Temp = Menuenr + 1
         End If
         Lcd Zeilenarray(temp)
         Gosub Tasten_pause                                       ' Tastenbremse
         Gosub Tastaturabfrage
         If Plus = 1 Then
            Incr Menuenr
            If Menuenr > Maxmenue Then Menuenr = 1
         End If
         If Minus = 1 Then
            Decr Menuenr
            If Menuenr = 0 Then Menuenr = Maxmenue
         End If
         If Ok > 0 Or Restart = 1 Then Exit Sub
      Loop
End Sub
'*******************************************************************************
'   QRG Auf/Ab Routine                                                         *
'*******************************************************************************
Sub Auf_ab(byref Parameter As Dword , byref Step_khz As Word , byref Faktor_step As Byte , byref Faktor As Byte , byref Lo_p_m As Byte , byref Lo_x As Word , Byval Pmax As Dword , Byval Pmin As Dword , Byval Ptrx As String)
   Do
      Cls
      Lcd Ptrx
      Locate 2 , 1
      Parameter_temp = Parameter * Faktor
      Parameter_temp1 = Lo_x * 1000
      Select Case Lo_p_m
         Case 1
            Parameter_temp = Parameter_temp1 + Parameter_temp
         Case 2
            Parameter_temp = Parameter_temp1 - Parameter_temp
      End Select
      Parameter_temp1 = Parameter_temp / 1000
      Lcd Parameter_temp1
      'Print Parameter_temp1;
      Lcd "."
      'Print ";";
      Parameter_temp1 = Parameter_temp Mod 1000
      If Parameter_temp1 < 100 Then Lcd "0"
      If Parameter_temp1 < 10 Then Lcd "0"
      Lcd Parameter_temp1
      'Print Parameter_temp1
      Gosub Tasten_pause                                       ' Tastenbremse
      Gosub Tastaturabfrage
      If Plus = 1 Then
         Parameter_temp = Step_khz * Faktor_step
         Parameter = Parameter + Parameter_temp
         If Parameter > Pmax Then Parameter = Pmin
         Gosub Pruefe_alt
         Gosub Trx_fram_schreiben
      End If
      If Minus = 1 Then
         Parameter_temp = Step_khz * Faktor_step
         Parameter = Parameter - Parameter_temp
         If Parameter < Pmin Then Parameter = Pmax
         Gosub Pruefe_alt
         Gosub Trx_fram_schreiben
      End If
      If Ok > 0 Or Restart = 1 Then Exit Sub
   Loop

   Pruefe_alt:                                                 ' Typ1 Daten werden von RX/TX Soft nicht angefasst

      If Left(Ptrx,3) = Tx And Tx_typ = 1 Then
         Parameter_temp = Parameter \ Step_khz                 ' Alt-Daten berechnen
         Tx_pll = Parameter_temp
      End If
      If Left(Ptrx,3) = Rx And Rx_typ = 1 Then
         Parameter_temp = Parameter \ Step_khz
         Rx_pll = Parameter_temp
         'Parameter_temp = 479500\ Step_khz                    ' 479,5MHz Tuner-ZF dazuaddieren
         Parameter_temp = Rx_pll + 1856'Parameter_temp
         Rx_pll = Parameter_temp
      End If
   Return
End Sub
'*******************************************************************************
'*   Step_real Auf/Ab Routine                                                  *
'*******************************************************************************
Sub Step_einstellung(byref Stepxfaktor As Byte , Byref Stepxkhz As Word , Byval Stepxtrx As String , Byval Step__einheit As String)
   Do
      Cls
      Lcd Stepxtrx
      Locate 2 , 1
      Temp_w = Stepxkhz * Stepxfaktor
      Lcd Temp_w
      Lcd Step__einheit
      Gosub Tasten_pause                                       ' Tastenbremse
      Gosub Trx_fram_schreiben
      Gosub Tastaturabfrage
      If Plus = 1 Then
         Stepxfaktor = Stepxfaktor * 2
         If Stepxfaktor < 1 Then Stepxfaktor = 1               ' 2*128 = 0 !!!!!
      End If
      If Minus = 1 Then
         Stepxfaktor = Stepxfaktor / 2
         If Stepxfaktor < 1 Then Stepxfaktor = 128
      End If
      If Ok = 2 Then Gosub Step_referenz
      If Ok = 1 Or Restart = 1 Then Exit Sub
   Loop
   'hier kommt ma nie vorbei nur durch Sprung
   Step_referenz:
      Temp_step = 1
      Temp_w = Stepxkhz
      Do
         Cls
         Lcd "Step Ref"
         Lowerline                                                ' 2. Zeile
         Lcd Temp_w
         Lcd Khz
         Gosub Tasten_pause                                       ' Tastenbremse
         Gosub Tastaturabfrage
         If Plus = 1 Then
            Temp_w = Temp_w + Temp_step
         End If
         If Minus = 1 Then
            Temp_w = Temp_w - Temp_step
         End If
         If Ok = 2 Then                                           ' wenn Menue-Taste lnger gedrckt ist
            Temp_step = Temp_step * 10                             ' dann nchste Dezimalstelle einstellen
            If Temp_step > 1000 Then Temp_step = 1
         End If
         If Ok = 1  Or Restart = 1 Then
            Ok = 0                                                ' sonst springt man gleich 2 Ebenen hher
            Stepxkhz = Temp_w
            Gosub Trx_fram_schreiben
            Return
         End If
      Loop
   Return
End Sub
'*******************************************************************************
'*   Nummer Auf/Ab Routine                                                     *
'*******************************************************************************
Sub Nr_auf_ab(byref Nr_parameter As Byte , Byval Nr_step As Byte , Byval Nr_pmax As Byte , Byval Nr_pmin As Byte , Byval Nt_trx As String)
   Do
      Cls
      Lcd Nt_trx
      Locate 2 , 1
      Lcd Nr_parameter
      Gosub Tasten_pause                                       ' Tastenbremse
      Gosub Tastaturabfrage
      If Plus = 1 Then
         Nr_parameter = Nr_parameter + Nr_step
         If Nr_parameter > Nr_pmax Then Nr_parameter = Nr_pmin
      End If
      If Minus = 1 Then
         Nr_parameter = Nr_parameter - Nr_step
         If Nr_parameter < Nr_pmin Then Nr_parameter = Nr_pmax
      End If
      'If OK = 2 then Gosub FRAM_anzeigen
      If Ok > 0 Or Restart = 1 Then Exit Sub
   Loop
End Sub
'*******************************************************************************
'*   Step Auf/Ab Routine                                                       *
'*******************************************************************************
Sub Step_auf_ab(byref Step_parameter As Word , Byval Step_step As Word , Byval Step_pmax As Word , Byval Step_pmin As Word , Byval Step_trx As String , Byval Step_einheit As String)
   Do
      Cls
      Lcd Step_trx
      Locate 2 , 1
      Lcd Step_parameter
      Lcd Step_einheit
      Gosub Tasten_pause                                       ' Tastenbremse
      Gosub Tastaturabfrage
      If Plus = 1 Then
         Step_parameter = Step_parameter + Step_step
         If Step_parameter > Step_pmax Then Step_parameter = Step_pmin
      End If
      If Minus = 1 Then
         Step_parameter = Step_parameter - Step_step
         If Step_parameter < Step_pmin Then Step_parameter = Step_pmax
      End If
      If Ok = 2 Then                                           ' wenn Menue-Taste lnger gedrckt ist
         Step_step = Step_step * 10                            ' dann nchste Dezimalstelle einstellen
         If Step_step > 1000 Then Step_step = 1
      End If
      If Ok = 1 Or Restart = 1 Then Exit Sub
      Gosub Pruef_tt_alt
      Gosub Trx_fram_schreiben
   Loop
   goto raus_step_auf_ab
   Pruef_tt_alt:
   'Fr alte TX-Tontrger-Daten die Berechnung starten
      If Txmenuenr = 4 And Hmenuenr = 2 And Tx_typ = 1 Then
         Tx_tt_pll = Step_parameter * 10
         Tx_tt_pll = Tx_tt_pll + 27000
      End If
   Return
   raus_step_auf_ab:
End Sub

'*******************************************************************************
'*   Bit ein aus  Routine                                                      *
'*******************************************************************************
Sub Bit_ein_aus(byref Bit_parameter As Byte , Byval Anzeige_bit As String , Byval Max_zustand As Byte , Byval Lcd0 As String , Byval Lcd1 As String , Byval Lcd2 As String )
   Do
      Cls
      Lcd Anzeige_bit
      Locate 2 , 1
      Select Case Bit_parameter
         Case 0
            Lcd Lcd0
         Case 1
            Lcd Lcd1
         Case Else
            Lcd Lcd2
      End Select
      Gosub Tasten_pause                                       ' Tastenbremse
      Gosub Tastaturabfrage
      If Plus = 1 Or Minus = 1 Then
         Incr Bit_parameter
         If Bit_parameter > Max_zustand Then Bit_parameter = 0
      End If
      If Ok > 0 Or Restart = 1 Then Exit Sub
   Loop
End Sub
'*******************************************************************************
'*   Tastaturabfrage raus kommt: Plus=1 Minus=1 OK=1 oder OK=2                 *
'*******************************************************************************
Tastaturabfrage:
   Ok_cnt = 0
   Plus = 0
   Minus = 0
   Ok = 0
   Do
      If T_auf = 0 Then                                         ' Auf-Abfrage
         Plus = 1
         'print "Taste +"
         Exit Do
      End If
      If T_ab = 0 Then                                          ' Ab-Abfrage
         Minus = 1
         'print "Taste -"
         Exit Do
      End If
      If T_menu = 0 Then                                        ' Menue-Abfrage Taste kann lnger gedrckt werden
         Ok = 1
         Do                                                     ' Zhlschleife
            Incr Ok_cnt
            Waitms 1                                            ' in 1 ms Schritten
         Loop Until T_menu = 1                                  ' Ablauf wird angehalten bis Taste losgelassen
         If Ok_cnt > 500 Then                                   ' wenn lnger als 500msgedrckt, dann
            Ok = 2
         End If
         Exit Do
      End If
      if Fram_timer_enable = 1 Then
         If Fram_timer_flag = 1 Then
            Fram_timer_flag = 0
            ' Fram lesen und Prfen
            Gosub Trx_fram_lesen
         End If
      Else
         if menueebene = 1 then Menue_timer_cnt = Menue_timeout ' Menue-Timer wiederauffllen wenn im oberten Menue
         Gosub Sdcl_test                                        ' Prfen ob Leitungen ok sind
      End If
         ' raus wenn Menue-Timeout
      If Menue_timer_flag = 1 or Restart = 1 Then            ' Bei keinem Tastendruck zurck ins oberste Menue
         Menue_timer_flag = 0
         Restart = 1
         Exit Do
      End If
      If Refresh = 1 Then
         Refresh = 0
         Return
      End If
   Loop
   Menue_timer_cnt = Menue_timeout                             ' Menue-Timer wiederauffllen
Return
'*******************************************************************************
'*   Fram lesen und schreiben                                                  *
'*******************************************************************************
'+++++++++++++++++++++++
'+ PCA-Schalter ffnen +
'+ PCA_Port ist TRXNr  +
'+++++++++++++++++++++++
Pca_oeffnen:
   Pcaschalter = Pca_port - 1                                  ' Rx bzw. TX Nummer in PCA-Bus-Nummer umrechnen
   Pcaschalter = 2 ^ Pcaschalter                               ' = 2^(Rtx#-1)
   Do
      If Twi_fehler_cnt = Versuche Then Exit Do                ' nach n Versuchen abbrechen
      Twi_mst_addr = Pca_addr                                  ' PCA AdressedieserSteuerung
      Twi_mt_cntr = 1                                          ' 1 Byte senden
      Twi_mt_data = Varptr(pcaschalter)                        ' ab der Adresse sollen die Daten gesendet werden
      Twi_mr_cntr = 0
      Gosub Run_wait_master                                    ' auf gehts
   Loop Until Twi_mst_flag = 0
Return
'++++++++++++++++++++++++++
'+ PCA-Schalter schlieen +
'+ PCA_Port ist 0         +
'++++++++++++++++++++++++++
'Pca_schliessen:
'   Temp = 0                                                    '???
'   Do
'      If Twi_fehler_cnt = Versuche Then Exit Do                ' nach n Versuchen abbrechen
'      Twi_mst_addr = Pca_addr                                  ' PCA AdressedieserSteuerung
'      Twi_mt_cntr = 1                                          ' 1 Byte senden
'      Twi_mt_data = Varptr(temp)                               ' ab der Adresse sollen die Daten gesendet werden
'      Twi_mr_cntr = 0                                          ' 0 zulesenden Daten
'      Gosub Run_wait_master                                    ' auf gehts
'   Loop Until Twi_mst_flag = 0                                 ' 0 zulesenden Daten
'   If Twi_fehler_cnt > 0 Then                                  ' Falls Fehler PCA per Hardware-Reset zurckschalten
'   Pca_r = 0                                                ' PCA zurcksetzen
'   Pca_r = 1
'   End If
'Return
'++++++++++++++++++
'+ PCF Schreiben  +
'++++++++++++++++++
Pcf_schreiben:
   Gosub Pcf_dat_drehen
   Do
      If Twi_fehler_cnt = Versuche Then Exit Do                ' nach n Versuchen abbrechen
      Twi_mst_addr = Pcf_addr(pcfmenuenr)                      ' PCF IC-Adresse (66 bis 70)
      Twi_mt_cntr = 1                                          ' 1 Byte senden
      Twi_mt_data = Varptr(pcf_dat(pcfmenuenr))                ' ab der Adresse sollen die Daten gesendet werden
      Twi_mr_cntr = 0                                          ' 0 zulesenden Daten
      Gosub Run_wait_master                                    ' auf gehts
   Loop Until Twi_mst_flag = 0
   Gosub Pcf_dat_drehen
Return
'++++++++++++++++++
'+ PCF Lesen      +
'++++++++++++++++++
Pcf_lesen:
   Gosub Pcf_dat_drehen
   Do
      If Twi_fehler_cnt = Versuche Then exit do                ' nach n Versuchen abbrechen
      Twi_mst_addr = Pcf_addr(pcfmenuenr)                      ' PCF IC-Adresse (66 bis 70)
      Twi_mt_cntr = 0                                          ' 0 Byte senden
      Twi_mr_cntr = 1                                          ' 1 Bytes zulesenden Daten
      Twi_mr_data = Varptr(pcf_dat(pcfmenuenr))                ' ab der Adresse sollen die Daten zurckgeschrieben werden
      Gosub Run_wait_master                                    ' auf gehts
   Loop Until Twi_mst_flag = 0
Pcf_dat_drehen:
   Temp = Pcf_dat(pcfmenuenr)
   For M = 0 To 7
      L = 7 - M
      Pcf_dat(pcfmenuenr).m = Temp.l
   Next
Return
'++++++++++++++++++
'+ REL Schreiben  +
'++++++++++++++++++
Rel_schreiben:
   Rel_send_dat(1) = Relmenuenr                                ' Sendedaten vorbereiten
   Rel_send_dat(2) = Rel_dat(relmenuenr)
   Do
      If Twi_fehler_cnt = Versuche Then Exit Do                ' nach n Versuchen abbrechen
      Twi_mst_addr = Rel_addr                                  ' REL IC-Adresse (HEX66 102)
      Twi_mt_cntr = 2                                          ' 2 Byte senden
      Twi_mt_data = Varptr(rel_send_dat(1))                    ' ab der Adresse sollen die Daten gesendet werden
      Twi_mr_cntr = 0                                          ' 0 zulesenden Daten
      Gosub Run_wait_master                                    ' auf gehts
   Loop Until Twi_mst_flag = 0
Return
'++++++++++++++++++
'+ REL Lesen      +
'++++++++++++++++++
Rel_lesen:
   Rel_send_dat(1) = 65
   Do
      If Twi_fehler_cnt = Versuche Then Return 'Exit Do                ' nach n Versuchen abbrechen
      Twi_mst_addr = Rel_addr                                  ' REL IC-Adresse (HEX66 102)
      Twi_mt_cntr = 1                                          ' 1 Byte senden
      Twi_mt_data = Varptr(rel_send_dat(1))                    ' 64+1 = Relaisbox auslesen
      Twi_mr_cntr = 4                                          ' 4 Bytes zulesenden Daten
      Twi_mr_data = Varptr(rel_lese_dat(1))                    ' ab der Adresse sollen die Daten zurckgeschrieben werden
      Gosub Run_wait_master                                    ' auf gehts
   Loop Until Twi_mst_flag = 0
   'Es kommen 2 Bytes zuerst Port D, dann PortC
   'Relaisnummern PortC 3210          1234
   'Relaisnummern PortD 7654 0123     5678 9ABC
   For K = 0 To 3                                              ' die ersten 8 Schaltzustnde bermitteln
      L = K + 9
      Rel_dat(l) = Rel_lese_dat(1).k
   Next
   For K = 0 To 3
      L = 7 - K                                               ' die ersten 8 Schaltzustnde bermitteln
      Rel_dat(5 + K) = Rel_lese_dat(1).l
   Next
   For K = 0 To 3
      L = 3 - K                                               ' die letzten 4 Schaltzustnde bermitteln
      Rel_dat(k + 1) = Rel_lese_dat(2).l                      ' bits in QI-RelaisBox Soft negiert
   Next
Return

'++++++++++++++++++
'+ Fram Schreiben +
'++++++++++++++++++
Fram_schreiben:
   select case Hmenuenr
      case 1
   'RX Daten schreiben
         Temp = Twi_rx_buff(2)                                       ' Korrektur wegen alter Schreibweise
         Twi_rx_buff(2) = Twi_rx_buff(3)
         Twi_rx_buff(3) = Temp

         Do
            If Twi_fehler_cnt = Versuche Then Exit Do                ' nach n Versuchen abbrechen
            Twi_mst_addr = Fram_addr                                 ' IC-Adresse (160)
            Twi_mt_cntr = 18                                         ' 18 Byte senden
            Twi_mt_data = Varptr(twi_rx_buff(1))                     ' ab der Adresse sollen die Daten gesendet werden
            Twi_mr_cntr = 0                                          ' 0 zulesenden Daten
            Gosub Run_wait_master                                    ' auf gehts
         Loop Until Twi_mst_flag = 0
         Pca_r = 0                                                   ' PCA zurcksetzen
         Pca_r = 1
         Temp = Twi_rx_buff(2)                                       ' Korrektur wegen alter Schreibweise
         Twi_rx_buff(2) = Twi_rx_buff(3)
         Twi_rx_buff(3) = Temp

   'TX Daten schreiben
      case 2
         Temp = Twi_tx_buff(2)                                       ' Korrektur wegen alter Schreibweise
         Twi_tx_buff(2) = Twi_tx_buff(3)
         Twi_tx_buff(3) = Temp
         Temp = Twi_tx_buff(4)
         Twi_tx_buff(4) = Twi_tx_buff(5)
         Twi_tx_buff(5) = Temp

         Do
            If Twi_fehler_cnt = Versuche Then Exit Do                ' nach n Versuchen abbrechen
            Twi_mst_addr = Fram_addr                                 ' IC-Adresse (160)
            Twi_mt_cntr = 24                                         ' 24 Byte senden
            Twi_mt_data = Varptr(twi_tx_buff(1))                     ' ab der Adresse sollen die Daten gesendet werden
            Twi_mr_cntr = 0                                          ' 0 zulesenden Daten
            Gosub Run_wait_master                                    ' auf gehts
         Loop Until Twi_mst_flag = 0
         Pca_r = 0                                                   ' PCA zurcksetzen
         Pca_r = 1
         Temp = Twi_tx_buff(2)                                       ' Korrektur wegen alter Schreibweise
         Twi_tx_buff(2) = Twi_tx_buff(3)
         Twi_tx_buff(3) = Temp
         Temp = Twi_tx_buff(4)
         Twi_tx_buff(4) = Twi_tx_buff(5)
         Twi_tx_buff(5) = Temp
   end select
Return
'+++++++++++++++++++++++
'+ Fram-Call Schreiben +
'+++++++++++++++++++++++
Fram_call_schreiben:
   Do
      If Twi_fehler_cnt = Versuche Then Exit Do                ' nach n Versuchen abbrechen
      Twi_mst_addr = Fram_addr                                 ' IC-Adresse (160)
      Twi_mt_cntr = 9                                          ' 9 Byte senden
      Twi_mt_data = Varptr(osd_addr)                           ' ab der Adresse sollen die Daten gesendet werden
      Twi_mr_cntr = 0                                          ' 0 zulesenden Daten
      Gosub Run_wait_master                                    ' auf gehts
   Loop Until Twi_mst_flag = 0
   Do
      If Twi_fehler_cnt = Versuche Then Exit Do                ' nach n Versuchen abbrechen
      Twi_mst_addr = Osd_ctrl_addr                             ' IC-Adresse (96)
      Twi_mt_cntr = 9                                          ' 8 Byte senden
      Twi_mt_data = Varptr(Osd_addr)                           ' ab der Adresse sollen die Daten gesendet werden
      Twi_mr_cntr = 0                                          ' 0 zulesenden Daten
      Gosub Run_wait_master                                    ' auf gehts
   Loop Until Twi_mst_flag = 0
   Pca_r = 0                                                   ' PCA zurcksetzen
   Pca_r = 1
Return
'++++++++++++++
'+ Fram lesen +
'++++++++++++++
Fram_lesen:
   select case Hmenuenr
      case 1
   'RX Daten Lesen
         Do
            If Twi_fehler_cnt = Versuche Then Exit Do                ' nach n Versuchen abbrechen
            Twi_mst_addr = Fram_addr                                 ' IC-Adresse (160)
            Twi_mt_cntr = 1                                          ' 1 Byte senden
            Twi_mt_data = Varptr(twi_rx_buff_t(1))                   ' ab der Adresse sollen die Daten gelesen werden
            Twi_mr_cntr = 17                                         ' 17 Bytes zulesenden Daten
            Twi_mr_data = Varptr(twi_rx_buff_t(2))                   ' ab der Adresse sollen die Daten zurckgeschrieben werden
            Gosub Run_wait_master                                    ' auf gehts
         Loop Until Twi_mst_flag = 0
         Pca_r = 0                                                   ' PCA zurcksetzen
         Pca_r = 1
         Temp = Twi_rx_buff_t(2)                                     ' Korrektur wegen alter Schreibweise
         Twi_rx_buff_t(2) = Twi_rx_buff_t(3)
         Twi_rx_buff_t(3) = Temp
      case 2
   'TX Daten lesen
         Do
            If Twi_fehler_cnt = Versuche Then Exit Do                ' nach n Versuchen abbrechen
            Twi_mst_addr = Fram_addr                                 ' IC-Adresse (160)
            Twi_mt_cntr = 1                                          ' 1 Byte senden
            Twi_mt_data = Varptr(twi_tx_buff_t(1))                   ' ab der Adresse sollen die Daten gesendet werden
            Twi_mr_cntr = 23                                         ' 23 Bytes zulesenden Daten
            Twi_mr_data = Varptr(twi_tx_buff_t(2))                   ' ab der Adresse sollen die Daten gesendet werden
            Gosub Run_wait_master                                    ' auf gehts
         Loop Until Twi_mst_flag = 0
         Pca_r = 0                                                   ' PCA zurcksetzen
         Pca_r = 1
         Temp = Twi_tx_buff_t(2)                                     ' Korrektur wegen alter Schreibweise
         Twi_tx_buff_t(2) = Twi_tx_buff_t(3)
         Twi_tx_buff_t(3) = Temp
         Temp = Twi_tx_buff_t(4)
         Twi_tx_buff_t(4) = Twi_tx_buff_t(5)
         Twi_tx_buff_t(5) = Temp
   end select
Return
'+++++++++++++++++++
'+ Fram-Call lesen +
'+++++++++++++++++++
Fram_call_lesen:
   Do
      If Twi_fehler_cnt = Versuche Then Exit Do                ' nach n Versuchen abbrechen
      Twi_mst_addr = Fram_addr                                 ' IC-Adresse (160)
      Twi_mt_cntr = 1                                          ' 1 Byte senden
      Twi_mt_data = Varptr(osd_addr)                           ' ab der Adresse sollen die Daten gelesen werden
      Twi_mr_cntr = 8                                          ' 17 Bytes zulesenden Daten
      Twi_mr_data = Varptr(osd_call)                           ' ab der Adresse sollen die Daten zurckgeschrieben werden
      Gosub Run_wait_master                                    ' auf gehts
   Loop Until Twi_mst_flag = 0
   Pca_r = 0                                                   ' PCA zurcksetzen
   Pca_r = 1
Return
'+++++++++++++++++++
'+ Zusammengefasst +
'+++++++++++++++++++
Trx_fram_schreiben:
   Gosub Pca_oeffnen
   if Twi_mst_flag = 0 Then Gosub Fram_schreiben
   Pca_r = 0                                                   ' PCA zurcksetzen
   Pca_r = 1
   Twi_fehler_cnt = 0
   'Print "Neu geschriebenen"
Return

Osd_call_schreiben:
   Gosub Pca_oeffnen
   if Twi_mst_flag = 0 Then Gosub Fram_call_schreiben
   Pca_r = 0                                                   ' PCA zurcksetzen
   Pca_r = 1
   Twi_fehler_cnt = 0
Return

Trx_fram_lesen:
   Gosub Pca_oeffnen
   if Twi_mst_flag = 0 Then Gosub Fram_lesen
   Pca_r = 0                                                   ' PCA zurcksetzen
   Pca_r = 1
   'FRam erneutlesen vorbereiten:
   'Variablen umkopieren:
   select case hmenuenr
      case 1
         For i =1 to 18
            Twi_rx_buff_t2(i) =Twi_rx_buff_t(i)
         next
      case 2
         For i =1 to 24
            Twi_Tx_buff_t2(i) =Twi_tx_buff_t(i)
         next
   end select
   'Erneut lesen
   Gosub Pca_oeffnen
   if Twi_mst_flag = 0 Then
      Gosub Fram_lesen
   else
      Return
   end if
   Pca_r = 0                                                   ' PCA zurcksetzen
   Pca_r = 1
   ' Vergleichen
   Passt=0
   select case hmenuenr
      case 1
         For i =1 to 18
            If Twi_rx_buff_t2(i) <> Twi_rx_buff_t(i) Then Passt = Passt + 1
         next
      case 2
         For i =1 to 24
            IF Twi_Tx_buff_t2(i) <> Twi_tx_buff_t(i) Then Passt = Passt + 1
         next
   end select
   If Twi_mst_flag  = 0 and Passt = 0 Then
      Gosub Fram_daten_pruefen
   END IF
   if passt > 150 then Gosub Fram_daten_pruefen
   'Print "Neu gelesen"
Return

Osd_call_lesen:
   Gosub Pca_oeffnen
   if Twi_mst_flag = 0 Then Gosub Fram_call_lesen
   Pca_r = 0                                                   ' PCA zurcksetzen
   Pca_r = 1
   'If Twi_mst_flag = 0 Then Gosub Fram_daten_pruefen           '????
Return
'*******************************************************************************
'*   Fram Daten prfen + bergeben                                             *
'*   TX und RX Daten liegen doppelt vor                                        *
'*******************************************************************************
Fram_daten_pruefen:
   'zuerst berprfen ob sich ein Wert gendert hat.
   select case hmenuenr
      case 1
       ' RX-Daten Prfen
         If Rx_pll <> T_rx_pll Or _
            Rx_qrg <> T_rx_qrg Or _
            Rx_qrg_step <> T_rx_qrg_step Or _
            Rx_faktor_step <> T_rx_faktor_step Or _
            Rx_tt <> T_rx_tt Or _
            Rx_vid_pos_neg <> T_rx_vid_pos_neg Or _
            Rx_lo <> T_rx_lo Or _
            Rx_lo_p_m <> T_rx_lo_p_m Or _
            Rx_flags <> T_rx_flags Or _
            Rx_typ <> T_rx_typ Then
          ' Prfen auf sinnvolle Daten
            If T_rx_pll > 21200 Or _
               T_rx_pll < 4000 Or _
               T_rx_qrg > 4000000 Or _
               T_rx_qrg < 250000 Or _
               T_rx_qrg_step = 0 Or _
               T_rx_faktor_step = 0 Or _
               T_rx_faktor_step > 128 Or _
               T_rx_tt < 500 Or _
               T_rx_tt > 1000 Or _
               T_rx_vid_pos_neg > 1 Or _
               T_rx_lo > 47000 Or _
               T_rx_lo_p_m > 3 Or _
               T_rx_flags > 32 Or _
               T_rx_typ = 0 or _
               T_rx_typ > 10 Then
             ' letzte gltigen Daten schreiben
             ' in Fram ablegen und Fehleranzeigen
               Locate 1 , 1
               Lcd "FramDatErr"
               'Print   "FramDatErr"
               gosub Trx_fram_schreiben
               Refresh = 1
            Else
             ' Daten sind gltig also bernehmen
             ' Alt Daten umrechnen
               If Rx_typ = 1 Then
                  'If Rx_pll <> T_rx_pll Then
                     'Parameter_temp = 479500 \ T_rx_qrg_step      ' 479,5MHz Tuner-ZF abziehen
                  Parameter_temp = T_rx_pll - 1856 'Parameter_temp
                  Temp_w = Parameter_temp
                  T_rx_qrg = Temp_w * 256
                  'End If
               End If
               For I = 2 To 18
                  Twi_rx_buff(i) = Twi_rx_buff_t(i)
               Next
               Refresh = 1
            End If
         End If
      case 2
         'TX-Daten Prfem
         If Tx_pll <> T_tx_pll Or _
            Tx_tt_pll <> T_tx_tt_pll Or _
            Tx_ptt <> T_tx_ptt Or _
            Tx_vagc <> T_tx_vagc Or _
            Tx_pll_ee_daten <> T_tx_pll_ee_daten Or _
            Tx_qrg <> T_tx_qrg Or _
            Tx_qrg_step <> T_tx_qrg_step Or _
            Tx_faktor_step <> T_tx_faktor_step Or _
            Tx_tt <> T_tx_tt Or _
            Tx_vid_pos_neg <> T_tx_vid_pos_neg Or _
            Tx_lo <> T_tx_lo Or _
            Tx_lo_p_m <> T_tx_lo_p_m Or _
            Tx_faktor <> T_tx_faktor Or _
            Tx_typ <> T_tx_typ Then
          ' Prfen auf sinnvolle Daten
            If T_tx_pll < 4000 Or _
               T_tx_pll > 21200 Or _
               T_tx_tt_pll > 36000 Or _
               T_tx_tt_pll < 32000 Or _
               T_tx_ptt > 1 Or _
               T_tx_vagc > 1 Or _
               T_tx_pll_ee_daten > 8 Or _
               T_tx_qrg > 4000000 Or _
               T_tx_qrg < 250000 Or _
               T_tx_qrg_step = 0 Or _
               T_tx_faktor_step = 0 Or _
               T_tx_faktor_step > 128 Or _
               T_tx_tt < 500 Or _
               T_tx_tt > 1000 Or _
               T_tx_vid_pos_neg > 1 Or _
               T_tx_lo > 47000 Or _
               T_tx_lo_p_m > 3 Or _
               T_tx_faktor > 10 or _
               T_tx_typ > 10 Then
             ' letzte gltigen Daten schreiben
             ' in Fram ablegen und Fehleranzeigen
               Locate 1 , 1
               Lcd "FramDatErr"
               'Print "FramFehler"
               gosub Trx_fram_schreiben
               Refresh = 1
            Else
             ' Daten sind gltig also bernehmen
             ' Alt Daten umrechnen
               If Tx_typ = 1 Then
                  If Tx_pll <> T_tx_pll Then
                     T_tx_qrg = T_tx_pll * 125
                  End If
                  If Tx_tt_pll <> T_tx_tt_pll Then
                     T_tx_tt = T_tx_tt_pll - 27000
                     T_tx_tt = T_tx_tt / 10
                  End If
               End If
               For I = 2 To 24
                  Twi_tx_buff(i) = Twi_tx_buff_t(i)
               Next
               Refresh = 1
            End If
         End If
   end select
Return
'*******************************************************************************
'*   SDA und SCl berprfen und ggf PCA Resetten                               *
'*******************************************************************************
Sdcl_test:
   TWCR = &B00000000                                       ' Sonst keine echte Portinfo
   Config Pinc.5 = Input
   Config Pinc.4 = Input
   If T_sda = 0 Then
      Waitms 5
      If T_sda = 0 Then
         Sda_scl_pc = Sda_scl_pc + 1
      End If
   End If
   If T_scl = 0 Then
      Waitms 5
      If T_scl = 0 Then
         Sda_scl_pc = Sda_scl_pc + 1
      End If
   End If
   If T_sda = 1 And T_scl = 1 Then
      Sda_scl_pc = 0
   End If
   If Sda_scl_pc > 350 Then                                ' mu wirklich fast 1 Minute down sein
      Sda_scl_pc = 0
      Pca_r = 0                                            ' PCA zurcksetzen
      Pca_r = 1
   End If
   Twcr = &B00000100
Return
'*******************************************************************************
'*   Tasten pause zum Code sparen                                              *
'*******************************************************************************
Tasten_pause:
   Waitms 175
Return
'*******************************************************************************
'*   IC-Multimaster ISR                                                       *
'*******************************************************************************
'+++++++++++++++++++++++++++++
'+ MultiMaster RX/TX Routine +
'+++++++++++++++++++++++++++++
Run_wait_master:
   Gosub Mst_start                                          ' Aufruf ( da drin passierts!!)
   Select Case Twi_mst_flag                                 ' Ergebnis ?
      Case Twi_m_sent:                                      ' (1) gesendet
         Twi_mst_flag = 0
      Case Twi_m_recv:                                      ' (2) geholt
         Twi_mst_flag = 0
      Case Else                                             ' (3) timeout irgendein Problem z.B.
         Incr Twi_fehler_cnt                                ' Fehlerzhler
         'Print "TWI Fehler"
         Twcr = &B00000000
         Config Pinc.5 = Input
         Config Pinc.4 = Input
         Twcr = &B00000100
   End Select
Return
'*******************************************************************************
'*   Timerkonfiguration                                                        *
'*******************************************************************************
'+++++++++++++++++++++++++++
'+ Timer0 fr Fram-Abfrage +
'+++++++++++++++++++++++++++
Fram_timer:                                                 ' Timer1 Auswertung
   Decr Fram_timer_cnt
   If Fram_timer_cnt = 0 Then
      Fram_timer_cnt = Fram_timeout
      Fram_timer_flag = 1                                   ' Timerflag nach dem Lesen wieder  0 setzen
   End If
Return
'++++++++++++++++++++++++
'+ Timer1 fr Drehgeber +                                   ' noch nicht verwendet
'++++++++++++++++++++++++

'+++++++++++++++++++++++++++++
'+ Timer2 fr Menue-Ausstieg +
'+++++++++++++++++++++++++++++
Menue_timer:                                                ' Timer2 Auswertung
   Decr Menue_timer_cnt
   If Menue_timer_cnt = 0 Then
      Menue_timer_cnt = Menue_timeout
      Menue_timer_flag = 1                                  ' Timerflag nach dem Lesen wieder  0 setzen
   End If
Return
'*******************************************************************************
'*   EEPromwerte beim Brennen speichern                                        *
'*******************************************************************************
$eeprom
Data 6560%                                                  ' 0  2 Byte RX Teilerfaktor
'Data 1204224&                                               ' 2  4 Bytes RX QRG in KHz
Data 1250000&                                               ' 2  4 Bytes RX QRG in KHz
Data 125%                                                   ' 6  2 Bytes RX QRG Step in kHz
Data 1                                                      ' 8  1 Byte RX Step Faktor
Data 650%                                                   ' 9  2 Bytes RX Tontrger QRG in 10kHz
Data 0                                                      ' 11 1 Byte RX Video Pos/Neg
Data 10000%                                                 ' 12 2 Bytes RX-LO in MHz
Data 0                                                      ' 14 1 Byte RX-LO 0 + -
Data &B0001_1111                                            ' 15 1 Byte RX Flags
Data 3                                                      ' 16 1 Byte RX Typ alt neu...

Data 9600%                                                  ' 17 2 Byte TX Teilerfaktor
Data 33500%                                                 ' 19 2 Byte TX Tontrger Teilerfaktor
Data 0                                                      ' 21 1 Byte TX PTT
Data 1                                                      ' 22 1 Byte TX Video-AGC
Data 0                                                      ' 23 1 Byte TX Pll Lock Fehlerzhler
Data &B0000_0111                                            ' 24 1 Byte TX Steuerkarten Konfiguration
Data 1200000&                                               ' 25 4 Bytes TX QRG in KHz
Data 125%                                                   ' 29 2 Bytes TX QRG Step in kHz
Data 1                                                      ' 31 1 Byte TX Step Faktor
Data 650%                                                   ' 32 2 Byte TX Tontrger QRG in 10kHz
Data 1                                                      ' 34 1 Byte TX Video Pos/Neg
Data 10000%                                                 ' 35 2 Bytes TX-LO in MHz
Data 0                                                      ' 37 1 Byte TX-LO 0 + -
Data 1                                                      ' 38 1 Byte TX Vervielfachung
Data 3                                                      ' 39 1 Byte TX Typ alt neu  ....
Data &B1110_0000                                            ' 40 1 PCA-Adresse
Data 1                                                      ' 41 1 Hauptmenue Speicher
'Ab 42 - 255  Schalter Namen
'PCF Expander 1
' 42
Data "Schal1 1"
Data "Schal1 2"
Data "Schal1 3"
Data "Schal1 4"
Data "Schal1 5"
Data "Schal1 6"
Data "Schal1 7"
Data "Schal1 8"
'PCF Expander 2
' ab 127
Data "Schal2 1"
Data "Schal2 2"
Data "Schal2 3"
Data "Schal2 4"
Data "Schal2 5"
Data "Schal2 6"
Data "Schal2 7"
Data "Schal2 8"
'PCF Expander 3
' 190
Data "Schal3 1"
Data "Schal3 2"
Data "Schal3 3"
Data "Schal3 4"
Data "Schal3 5"
Data "Schal3 6"
Data "Schal3 7"
Data "Schal3 8"
'Relais Box
' 255
Data "REL1    "
Data "REL2    "
Data "REL3    "
Data "REL4    "
Data "REL5    "
Data "REL6    "
Data "REL7    "
Data "REL8    "
Data "REL9    "
Data "REL10   "
Data "REL11   "
Data "REL12   "
'OSD -Call sind in den FRAMs Eingetragen
'Data "NO1CALL "
'Data "NO2CALL "
'Data "NO3CALL "
'Data "NO4CALL "
'Data "NO5CALL "
'Data "NO6CALL "
'Data "NO7CALL "
'Data "NO8CALL "
$data